

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
    *                                                                   *
    *   Some DSP 0.2                                                    *
    *                                                                   *
    *   Copyright  2005   Sebastian Pipping <webmaster@hartwork.org>   *
    *                                                                   *
    *   --> http://www.hartwork.org                                     *
    *                                                                   *
    *                                                                   *
    *   This source code is released under LGPL.                        *
    *   See LGPL.txt for details.                                       *
    *                                                                   *
    \* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


#include "mod_revster.h"


void config_revster( struct winampDSPModule * this_mod );
int init_revster( struct winampDSPModule * this_mod );
int apply_revster( struct winampDSPModule * this_mod, short int * samples, int numsamples, int bps, int nch, int srate );
void quit_revster( struct winampDSPModule * this_mod );


////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
winampDSPModule mod_revster =
{
	"Reversed Stereo",
	NULL,			// hwndParent
	NULL,			// hDllInstance
	config_revster,
	init_revster,
	apply_revster,
	quit_revster
};


////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
void config_revster( struct winampDSPModule * this_mod )
{
	MessageBox(	this_mod->hwndParent,
				"Reversed Stereo\n"
				"\n"
				"Copyright  2005 Sebastian Pipping    \n"
				"--> http://www.hartwork.org",
				"About",
				MB_ICONINFORMATION );
}


////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
int init_revster( struct winampDSPModule * this_mod )
{
	return 0;	// Fine
}


////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
int apply_revster( struct winampDSPModule * this_mod, short int * samples, int numsamples, int bps, int nch, int srate )
{
	// Stereo?
	if( nch != 2 )
	{
		return numsamples;
	}


	// Swap channels
	const int block_len = numsamples * 2;
	short int temp;
	for( int i = 0; i < block_len; i += 2 )
	{
		temp = samples[ i ];
		samples[ i ] = samples[ i + 1 ];
		samples[ i + 1 ] = temp;
	}


	return numsamples;
}


////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
void quit_revster( struct winampDSPModule * this_mod )
{

}
